<?php

/**
 * @author Christoph
 */

/* @var $user cUser */
$data['template'] = 'filelist.tpl.php';

//Ordner und Dateien hinzufgen
if (isset($_GET['action']) && ($_GET['action'] === 'edit'))
{
    $data['template'] = 'edit_filelist.tpl.php';

// Erzeuge Datenbankobjekt fr filelist_ordner
    $db_filelist_ordner = new cDB($o_db, 'ordner');
    $a_filelist_ordner = $db_filelist_ordner->formdata('id', 'name');
    $a_filelist_ordner[0] = 'Kein bergeordneter Ordner';

    $f_addordner = new cForm();
    $f_addordner->start($_SERVER['PHP_SELF'] . '?action=edit', 'Neuen Ordner erstellen', 'addornder', '');
    $f_addordner->text('Name', 'Bitte geben Sie hier den Namen des Ordners an.', 'string');
    $f_addordner->dropdown('bergeordneter Ordner', 'Bitte whlen Sie hier den Ordner aus, der diesem bergeordnet sein soll.', $a_filelist_ordner);
    $f_addordner->submit('Ordner erstellen');
    $f_addordner->end();
    $data['f_addordner'] = $f_addordner;

    unset($a_filelist_ordner[0]);
    $f_uploadfile = new cForm(true);
    $f_uploadfile->start($_SERVER['PHP_SELF'] . '?action=edit', 'Datei hochladen', 'uploadfile');
    $f_uploadfile->text('Dateiname', 'Bitte geben Sie hier den Namen der Datei an.', 'string');
    $f_uploadfile->dropdown('Ordner', 'Bitte whlen Sie hier den Ordner aus, in dem die Datei liegen soll.', $a_filelist_ordner);
    $f_uploadfile->file('Datei', true, FILE_DIR);
    $f_uploadfile->submit('Hochladen');
    $f_uploadfile->end();
    $data['f_uploadfile'] = $f_uploadfile;

    $f_import = new cForm(true);
    $f_import->start($_SERVER['PHP_SELF'] . '?action=edit', 'Zip-Archiv importieren', 'ipmortzip');
    $f_import->text('Name', 'Bitte geben Sie hier einen Namen fr den Hauptordner ein.', 'string');
    $f_import->file('Zip-Archiv', false);
    $f_import->submit('Importieren');
    $f_import->end();
    $data['f_import'] = $f_import;

//berprfen, ob das uploadfile Formular richtig abgeschickt wurde
    if ($f_uploadfile->is_correctsend())
    {
// Erzeuge Datenbankobjekt fr filelist__files
        $db_files = new cDB($o_db, 'files');
        $db_files->Insert(array($f_uploadfile->a_input['dateiname'], $f_uploadfile->a_input['dateiname'] . '.' . $f_uploadfile->a_input['datei']['extension'], $f_uploadfile->a_input['datei']['filename'], $f_uploadfile->a_input['ordner']));
        $_SESSION['info'] = 'Die Datei wurde erfolgreich hochgeladen';
        redirect('?action=edit');
    }
    elseif ($f_uploadfile->b_error)
    {
        $data['errors'] = $f_uploadfile->a_errors;
    }

//bprfen ob das addordner Formular richtig abgeschickt wurde
    if ($f_addordner->is_correctsend())
    {
        $db_filelist_ordner->Insert(array($f_addordner->a_input['uebergeordneterordner'], $f_addordner->a_input['name']));
        $_SESSION['info'] = 'Der Ordner wurde erfolgreich erstellt';
        redirect('?action=edit');
    }
    elseif ($f_addordner->b_error)
    {
        $data['errors'] = $f_addordner->a_errors;
    }

    // Formular $f_import berprfen
    if ($f_import->is_correctsend())
    {
        if ($f_import->a_input['zip-archiv']['extension'] != 'zip')
        {
            $data['errors'] = array('Die Datei muss ein zip-Archiv sein.');
            return;
        }
        $zip = new ZipArchive;
        if ($zip->open($f_import->a_input['zip-archiv']['tmp_name']) === TRUE)
        {
            @mkdir(TMP_DIR . $f_import->a_input['name']);
            $zip->extractTo(TMP_DIR . $f_import->a_input['name'] . '/');
            $zip->close();

            $db_files = new cDB($o_db, 'files');
            $db_ordner = new cDB($o_db, 'ordner');

            function import(RecursiveDirectoryIterator $zeiger, $oid) {
                global $db_files;
                global $db_ordner;
                for ($zeiger->rewind(); $zeiger->valid(); $zeiger->next()) {
                    if ($zeiger->isDir() && !$zeiger->isDot())
                    {
                        $db_ordner->Insert(array($oid, $zeiger->getFilename()));
                        $new_oid = $db_ordner->getinsertid();
                        if ($zeiger->hasChildren())
                        {
                            $unterverzeichnis = $zeiger->getChildren();
                            import($unterverzeichnis, $new_oid);
                        }
                    }
                    elseif ($zeiger->isFile())
                    {
                        $filename = md5(uniqid(rand(), TRUE));
                        while (file_exists(FILE_DIR . $filename)) {
                            $filename = md5(uniqid(rand(), TRUE));
                        }
                        copy($zeiger->getPathname(), FILE_DIR . $filename);
                        $db_files->Insert(array($zeiger->getBasename(), $zeiger->getFilename(), $filename, $oid));
                    }
                }
            }
            $db_ordner->Insert(array(0, $f_import->a_input['name']));
            $oid = $db_ordner->getinsertid();
            import(new RecursiveDirectoryIterator(TMP_DIR . $f_import->a_input['name'] . '/'), $oid);

            function rrmdir($dir) {
                if (is_dir($dir))
                {
                    $objects = scandir($dir);
                    foreach ($objects as $object) {
                        if ($object != "." && $object != "..")
                        {
                            if (filetype($dir . "/" . $object) == "dir") rrmdir($dir . "/" . $object); else unlink($dir . "/" . $object);
                        }
                    }
                    reset($objects);
                    rmdir($dir);
                }
            }

            rrmdir(TMP_DIR . $f_import->a_input['name'] . '/');
        }else
        {
            $data['errors'] = array('Das zip-Archiv konnte nicht geffnet werden.');
            return;
        }
    }
    elseif ($f_import->b_error == true)
    {
        $data['errors'] = $f_import->a_errors;
    }
}

//Ordner bearbeiten
elseif (isset($_GET['action']) and ($_GET['action'] === 'editdir') and isset($_GET['dirid']) and is_numeric($_GET['dirid']))
{
    $dirid = $_GET['dirid'];
    $data['template'] = 'form.tpl.php';

    //Daten laden
    $db_filelist_ordner = new cDB($o_db, 'ordner');
    $a_ordner = $db_filelist_ordner->Select($dirid);
    if ($a_ordner == false)
    {
        die('Der Ordner wurde nicht gefunden');
    }
    $a_filelist_ordner = $db_filelist_ordner->formdata('id', 'name');
    unset($a_filelist_ordner[$dirid]);
    $a_filelist_ordner[0] = 'Kein bergeordneter Ordner';


    //Formular erstellen
    $f_editdir = new cForm();
    $f_editdir->start($_SERVER['PHP_SELF'] . '?action=editdir&dirid=' . $dirid, 'Ordner bearbeiten', 'editdir');
    $f_editdir->text('Name', 'Bitte geben Sie hier den Namen des Ordners an.', 'string', true, $a_ordner['name']);
    $f_editdir->dropdown('bergeordneter Ordner', 'Bitte whlen Sie hier den Ordner aus, der diesem bergeordnet sein soll.', $a_filelist_ordner, true, $a_ordner['pid']);
    $f_editdir->submit('Bearbeiten');
    $f_editdir->end();

    $data['form'] = $f_editdir;

    // Formular $f_editdir berprfen
    if ($f_editdir->is_correctsend())
    {
        $db_filelist_ordner->Update(array('name' => $f_editdir->a_input['name'], 'pid' => $f_editdir->a_input['uebergeordneterordner']), $dirid);
        $_SESSION['info'] = 'Der Ordner wurde erfolgreich bearbeitet.';
        redirect();
    }
    elseif ($f_editdir->b_error == true)
    {
        $data['template'] = 'form_error.tpl.php';
        $data['errors'] = $f_editdir->a_errors;
        $data['form'] = $f_editdir;
        return;
    }
}

//Ordner lschen
elseif (isset($_GET['action']) and ($_GET['action'] === 'deldir') and isset($_GET['dirid']) and is_numeric($_GET['dirid']))
{
    $dirid = $_GET['dirid'];
    $db_files = new cDB($o_db, 'files');
    $db_dirs = new cDB($o_db, 'ordner');

    $a_ordner = $db_dirs->Select($dirid);
    if ($a_ordner == false)
    {
        $data['template'] = 'error.tpl.php';
        $data['error'] = 'Der angegebene Ordner konnte nicht gefunden werden';
        return;
    }

    function deldir($dirid) {
        global $db_files;
        global $db_dirs;

        $a_ordner = $db_dirs->Select($dirid, '{"b2d":true}');
        if ($a_ordner == false)
        {
            return false;
        }

        $a_files = $db_files->Select('{"oid":' . $dirid . ', "b2d":true}');
        foreach ($a_files as $a_file) {
            unlink(FILE_DIR . $a_file['filename']);
        }
        $db_files->Delete('{"oid":' . $dirid . '}');

        $a_childs = $db_dirs->Select('{"pid":' . $dirid . ', "b2d":true}');
        if (is_array($a_childs))
        {
            foreach ($a_childs as $a_child) {
                deldir($a_child['id']);
            }
        }

        $db_dirs->Delete($dirid);
    }

    deldir($dirid);

    $_SESSION['info'] = 'Die Datei wurde erfolgreich gelscht.';
    redirect();
}

//Datei beabeiten
elseif (isset($_GET['action']) and ($_GET['action'] === 'editfile') and isset($_GET['fileid']) and is_numeric($_GET['fileid']))
{
    $fileid = $_GET['fileid'];
    $data['template'] = 'form.tpl.php';

    //Daten laden
    $db_filelist_files = new cDB($o_db, 'files');
    $a_file = $db_filelist_files->Select($fileid);
    if ($a_file == false)
    {
        die('Die Datei wurde nicht gefunden');
    }

    //Ordner laden
    $db_filelist_ordner = new cDB($o_db, 'ordner');
    $a_filelist_ordner = $db_filelist_ordner->formdata('id', 'name');

    //Formular erstellen
    $f_editfile = new cForm();
    $f_editfile->start($_SERVER['PHP_SELF'] . '?action=editfile&fileid=' . $fileid, 'Datei bearbeiten', 'editfile');
    $f_editfile->text('Name', 'Bitte geben Sie hier den Namen der Datei an.', 'string', true, $a_file['name']);
    $f_editfile->dropdown('Ordner', 'Bitte whlen sie hier den Ordner aus, in dem diese Datei liegen soll.', $a_filelist_ordner, true, $a_file['oid']);
    $f_editfile->submit('Bearbeiten');
    $f_editfile->end();

    $data['form'] = $f_editfile;

    // Formular $f_editfile berprfen
    if ($f_editfile->is_correctsend())
    {
        $db_filelist_files->Update(array('name' => $f_editfile->a_input['name'], 'oid' => $f_editfile->a_input['ordner']), $fileid);
        $_SESSION['info'] = 'Die Datei wurde erfolgreich bearbeitet.';
        redirect();
    }
    elseif ($f_editfile->b_error == true)
    {
        $data['template'] = 'form_error.tpl.php';
        $data['errors'] = $f_editfile->a_errors;
        $data['form'] = $f_editfile;
        return;
    }
}

//Datei lschen
elseif (isset($_GET['action']) and ($_GET['action'] === 'delfile') and isset($_GET['fileid']) and is_numeric($_GET['fileid']))
{
    $fileid = $_GET['fileid'];
    $db_files = new cDB($o_db, 'files');

    $a_file = $db_files->Select($fileid);
    if ($a_file == false)
    {
        $data['template'] = 'error.tpl.php';
        $data['error'] = 'Die angegebene Datei konnte nicht gefunden werden';
        return;
    }
    unlink(FILE_DIR . $a_file['filename']);
    $db_files->Delete($fileid);

    $_SESSION['info'] = 'Die Datei wurde erfolgreich gelscht.';
    redirect();
}
else
{
    require_once CLASS_PATH . 'cView.php';
    $cView = new cView($o_db, 'files');
    $db_files = new cDB($o_db, 'files');
    $data['files'] = $db_files->Select();
    $data['g_files'] = $cView->set_data($data['files'])->group('oid');
    $db_ordner = new cDB($o_db, 'ordner');
    $data['ordner'] = $db_ordner->Select();
    $data['g_ordner'] = $cView->set_data($data['ordner'])->group('pid');
    $data['print_ordner'] = function($pid) {
                global $data;
                global $cView;
                if (isset($data['g_ordner'][$pid]))
                {
                    foreach ($data['g_ordner'][$pid] as $key) {
                        $id = $data['ordner'][$key]['id'];
                        echo '<li>Ordner: ' . $data['ordner'][$key]['name'];

                            echo ' <a href="' . $_SERVER['PHP_SELF'] . '?action=editdir&dirid=' . $id . '"><img src="symbols/20/edit.png" alt="Bearbeiten" title="Bearbeiten" /></a>';
                            echo ' <a href="' . $_SERVER['PHP_SELF'] . '?action=deldir&dirid=' . $id . '"><img src="symbols/20/118.png" alt="Lschen" title="Lschen" /></a>';

                        if (isset($data['g_files'][$id]))
                        {
                            echo '<ul class="filelist_files">';
                            foreach ($data['g_files'][$id] as $fileid) {
                                echo '<li><a href="getfile.php?id=' . $data['files'][$fileid]['id'] . '&typ=filelist">' . $data['files'][$fileid]['name'] . '</a>';
                                
                                    echo'  <a href="' . $_SERVER['PHP_SELF'] . '?action=editfile&fileid=' . $data['files'][$fileid]['id'] . '"> <img src="symbols/18/edit.png" alt="Bearbeiten" title="Bearbeiten" /></a>
                                                 <a href="' . $_SERVER['PHP_SELF'] . '?action=delfile&fileid=' . $data['files'][$fileid]['id'] . '"> <img src="symbols/18/118.png" alt="Lschen" title="Lschen" /></a>';
                                echo'      </li>';
                            }
                            echo '</ul>';
                        }
                        if (isset($data['g_ordner'][$id]))
                        {
                            echo '<ul>';
                            $data['print_ordner']($id);
                            echo '</ul>';
                        }
                        echo '</li>';
                    }
                }

                return true;
            };
}
?>
