<?php
/**
 * @author Christoph
 */
/* @var $o_db mysqli */

include 'config.php';

/* Datenbanktabellen erzeugen */
echo 'Erzeuge Tabellen...<br>';

//Tabelle fr die Dateien:
$sql = 'CREATE TABLE IF NOT EXISTS `files` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `outputname` varchar(255) NOT NULL,
  `filename` varchar(50) NOT NULL,
  `oid` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=99';

$result = $o_db->query($sql);
if (!$result) {
    die ('Es gab ein Problem bei der Erstellung der Tabelle fr die Dateien: '.$db->error);
}
//Tabelle fr die Ordner:

$sql = 'CREATE TABLE IF NOT EXISTS `ordner` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `pid` int(10) unsigned NOT NULL,
  `name` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=30 ';
$result = $o_db->query($sql);
if (!$result) {
    die ('Es gab ein Problem bei der Erstellung der Tabelle fr die Ordner: '.$db->error);
}
echo 'Tabellen erzegt!<p></p>';

/* Ordner erzeugen */
echo 'Lege Ordner an... <br>';
//Temporre Ordner, alle Rechte nur fr Besitzer
if (!file_exists(TMP_DIR))
{
    mkdir(TMP_DIR, 0700);
}

//Ordner fr Dateien mit allen Rechten fr alle
if (!file_exists(FILE_DIR))
{
    mkdir(FILE_DIR,0777);
}

echo 'Ordner erzeugt!';
?>
