<?php
    /** PHP Einstellungen **/
    error_reporting(E_ALL);
    ini_set( 'session.use_only_cookies', '1' );
    ini_set( 'session.use_trans_sid', '0' );
    ini_set("display_errors", TRUE);
    
    
    /** Konstanten */

    //Seiteneinstellungen
    define('TITLE', 'Filesharing'); //Der Titel der Seite
    define('AUTHOR', ''); //Der Author der Seite
    define('KEYWORDS', 'filesharing,files'); //Keywords, die die Seite beschreiben
    

    //Datenkbank
    define('MYSQL_HOST', 'localhost');
    define('MYSQL_USER', 'root');
    define('MYSQL_PASS', '');
    define('MYSQL_DATABASE', 'test');
    
    //Dateigren
    define('MAX_FILE_SIZE', 100*1024*1024); //100 MB
    define ('UPLOAD_MAXSIZE', 10*1024*1024); // 10 MB

    //Ordner
    define('FILE_DIR', 'files/');
    define('CLASS_PATH', 'classes/');
    define('TMP_DIR', 'tmp/');

    //ICONS
    define('ICON_PATH' , 'icons/');
    define('ICON_EDITSIDE', ICON_PATH.'editside.png');
    define('ICON_ADDSIDE', ICON_PATH.'addside.png');
    define('ICON_DELETE', ICON_PATH.'delete.png');
    define('ICON_EDIT', ICON_PATH.'edit.png');
    define('ICON_UP', ICON_PATH.'up.png');
    define('ICON_DOWN', ICON_PATH.'down.png');


    
    /* Globale Variablen chekcen */
    $_SERVER['REMOTE_ADDR'] = filter_var($_SERVER['REMOTE_ADDR'], FILTER_VALIDATE_IP);
    $_SERVER['HTTP_USER_AGENT'] = filter_var($_SERVER['HTTP_USER_AGENT'], FILTER_SANITIZE_STRING);
    unset($_SERVER['HTTP_REFERER']);
    
    /** Session checken `*/
    session_start();
    if (isset( $_SESSION['server_SID']) === false)
    {
    	// Mglichen Session Inhalt l�schen
    	session_unset();
    	// Ganz sicher gehen das alle Inhalte der Session gelscht sind
    	$_SESSION = array();
    	// Session zerstren
    	session_destroy();
    	// Session neu starten
    	session_start();
    	// Neue Server-generierte Session ID vergeben
    	session_regenerate_id();
    	// Status festhalten
    	$_SESSION['server_SID'] = true;
    }

    //Header Daten setzen
    header('Content-type: text/html; charset=ISO-8859-1');

    //Datenbankverbindung herstellen
    $o_db = new mysqli(MYSQL_HOST, MYSQL_USER, MYSQL_PASS, MYSQL_DATABASE);
    if($o_db->connect_error) {
        throw new exception('Connect Error ('.$o_db->connect_errno.') '.$o_db->connect_error,1);
    }
?>