<?php

/**
 * @author Christoph Staudt
 * @copyright 2010
 * @project PSI-Online
 * @status Fertig 
 * @test --
 * @done --
 */
    if ($user->angemeldet === true){        
        $data['info'] = 'Sie sind bereits angemeldet';
        $data['template'] = 'info.tpl.php';
        return;
    }
    //Standard Templatedatei
    $data['template'] = 'form.tpl.php';
    
    //Text setzen
    $data['text'] =  '';
    
    //Formular Objekt erstellen und speichern
    $login_form = new cForm();
    $login_form->start($cPage->s_name, 'Einloggen', 'login', 'login', false);
    $login_form->text('E-Mail', 'Bitte geben Sie hier ihre E-Mail Adresse an, mit der Sie sich angemeldet haben.', 'email');
    $login_form->password('Passwort', '', 'string');
    $login_form->submit('Einloggen');
    $login_form->end();
    $data['form'] = $login_form;
    if ($login_form->is_correctsend('einloggen') === true){
        //User-Objekt erzeugen
        
        // Versuchen User einzuloggen
        if ($user->login($login_form->a_input['e-mail'],$login_form->a_input['passwort']) === true){
            //Wenn das Login erfolgreich war
            if ($user->update() === true){
                //SESSION setzen
                $_SESSION['angemeldet']   = true;
                $_SESSION['email'] = $login_form->a_input['e-mail'];
                $_SESSION['anmeldung']    = md5($_SERVER['REQUEST_TIME']);

                //Wenn die User-Informationen erfolgreich gesetzt werden konnten
                $_SESSION['info'] = 'Sie haben sich erfolgreich angemeldet';
                header('Location:'.$cPage->makename(DEFAULT_SIDEID));
                die();
            }
            else
            {
                // Wenn das setzen der User Informationen fehlgeschlagen ist
                $data['template'] = 'form_error.tpl.php';
                $data['error'] = 'Der Anmeldevorgang ist leider gescheitert'; 
            }
        }
        else
        {
         //Wenn das Login fehlgeschlagen ist   
            $data['template'] = 'form_error.tpl.php';
            $data['error'] = 'Ihre E-Mail Adresse oder Passwort war falsch. Bitte versuchen Sie es noch einmal.';    
        }         
    }
    elseif($login_form->b_error == true){
        $data['template'] = 'form_error.tpl.php';
        $data['errors'] = $login_form->a_errors;
    }      
?>